<?php
/**
* @version 1.5 - plgQRCodesLocal
* @package		Joomla
* @subpackage	Content
* @copyright	Copyright (C) 2012 Dave Airey. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plgQRCodesLocal');
require_once(JPATH_SITE.DS.'modules'.DS.'mod_qrcodes_local'.DS.'tmpl'.DS.'qr_img.php');

function plgQRCodesLocal( &$article, &$params, $limitstart )
{

	// simple performance check to determine whether bot should process further
	if ( strpos( $article->text, 'qrcodeslocal' ) === false ) {
		return true;
	}

	// Get Plugin info
	$plugin            =& JPluginHelper::getPlugin('content', 'qrcodeslocal');
	$pluginParams    = new JParameter( $plugin->params );

	// define the regular expression for the bot
	$regex = "#{qrcodeslocal}(.*?){\/qrcodeslocal}#s";

	// check whether plugin has been unpublished
	if ( !$pluginParams->get( 'enabled', 1 ) ) {
		$article->text = preg_replace( $regex, '', $row->text );
		return true;
	}

	// find all instances of plugin and put in $matches
	preg_match_all( $regex, $article->text, $matches );
	// Number of plugins
	$count = count( $matches[0] );

	// plugin only processes if there are any instances of the plugin in the text
	if ( $count ) {
		// Get plugin parameters
		//$style	= $pluginParams->def( 'style', -2 );

		plgQRCodesLocalCreateImage( $article, $matches, $count, $regex, $pluginParams );
	}

}

function plgQRCodesLocalCreateImage( &$row, &$matches, $count, $regex, &$botParams ) {

	for ( $i=0; $i < $count; $i++ )
	{
		$text_to_replace = str_replace( '{qrcodeslocal}', '', $matches[0][$i] );
		$text_to_replace = str_replace( '{/qrcodeslocal}', '', $text_to_replace );
		$row->text = str_replace( $matches[0][$i], getQRText($text_to_replace,$botParams), $row->text );
	}
}

function getQRText($picture_text, $botParams) {
	$picture_url = $picture_text;
	$SERVER_PATH_FOLDER = JPATH_CACHE.DS."qrcodes_local".DS;
	$CACHE_FOLDER = "cache".DS."qrcodes_local".DS;
	$expires_time = (int) $botParams->get( 'expires_time', 10080 );
	$expires_period = $botParams->get( 'expires_period', 'minutes' );

	// picture_text - NEED to REPLACE certain characters for file system
	// $picture_text = str_replace( array( " ", "/", ".", "?", "&", "=", "%", ",", "[", "]", "<", ">", "*", "!", "|", "\"", "'" ), "-", $picture_text );
	$picture_url = preg_replace("/[^a-z0-9_-s.]/i","-",$picture_url); 
	// CHECK IF QR CODE FOR THIS URL ALREADY EXISTS
	if (!file_exists($SERVER_PATH_FOLDER.$picture_url.".png") ) {
		// IF NOT CREATE IT
		// using function create($name, $url, $output, $type, $size, $data, $correct, $version)
		qrcode_image::create( $picture_url, $picture_text, $CACHE_FOLDER, "", 4, $picture_text, 'M', "" );
		chmod($SERVER_PATH_FOLDER.$picture_url.".png", 0640);
	}
	// CREATE AN EXPIRES FILE FOR THE CACHED FILE (IF ONE DOESN'T EXIST) WITHOUT THE IF UPDATES AT EACH USE.
	//if (!file_exists($SERVER_PATH_FOLDER.$picture_text.".png_expire") ) {
		$date = new DateTime();
		$date->modify('+'.$expires_time.' '.$expires_period);
		file_put_contents($SERVER_PATH_FOLDER.$picture_url.".png_expire",$date->getTimestamp());
		chmod($SERVER_PATH_FOLDER.$picture_url.".png_expire", 0640);
	//}
	$qr_code = '<img src="'.$CACHE_FOLDER.$picture_url.'.png" alt="QRCODE - '.$picture_text.'" />';

	return $qr_code;
}
?>
